<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="100px">
      <el-form-item label="团队名称" label-width="70px">
        <el-input
          v-model="queryParams.name"
          placeholder="请输入团队名称"
          clearable
          style="width: 140px;"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="团队类型">
        <el-select
          v-model="queryParams.type"
          placeholder="团队类型"
          clearable
          style="width: 240px"
        >
          <el-option
            v-for="dict in dict.type.team_type"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="销售员" label-width="70px">
        <el-input
          v-model="queryParams.salerPerson"
          placeholder="请输入销售员"
          clearable
          style="width: 140px;"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="创建人" label-width="70px">
        <el-input
          v-model="queryParams.createBy"
          placeholder="请输入创建人"
          clearable
          style="width: 140px;"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
              type="primary"
              plain
              icon="el-icon-plus"
              size="mini"
              @click="handleAdd"
              v-hasPermi="['teamMr:teamMr:add']"
            >新增</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table ref="tables" v-loading="loading" :data="dataList" border>
      <el-table-column label="序号" align="center" type="index" width="50"></el-table-column>
      <el-table-column label="团队名称" align="center" prop="name" />
      <el-table-column label="团队类型" align="center" prop="type">
        <template slot-scope="scope">
          <dict-tag :options="dict.type.team_type" :value="scope.row.type"/>
        </template>
      </el-table-column>
      <el-table-column label="客户负责人" align="center" prop="contact" />
      <el-table-column label="客户账号/联系电话" align="center" prop="mobile" />
      <el-table-column label="销售员" align="center" prop="salerPerson" />
      <el-table-column label="销售员联系电话" align="center" prop="salerMobile" />
      <el-table-column label="合约信息" align="center" prop="type">
        <template slot-scope="scope">
          <el-button type="text" @click="seeCenter(scope.row, 'img')">查看</el-button>
        </template>
      </el-table-column>
      <el-table-column label="账户余额" align="center" prop="balance" />
      <el-table-column label="授信额度" align="center" prop="grantQuota" />
      <el-table-column label="授信余额" align="center" prop="grantSurplus" />
      <el-table-column label="授信欠款" align="center" prop="grantUsed" />
      <el-table-column label="账户状态" align="center" prop="status">
        <template slot-scope="scope">
          <el-switch
            @change="updateStatusApi(scope.row)"
            v-model="scope.row.switchValue"
            :active-value="1"
            active-color="#13ce66"
            inactive-color="#ff4949">
          </el-switch>
        </template>
      </el-table-column>
      <el-table-column label="创建人" align="center" prop="createBy" />
      <el-table-column label="创建时间" align="center" prop="createTime">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.createTime) }}</span>
        </template>
      </el-table-column>
      <el-table-column label="审核状态" align="center" prop="checkStatus">
        <template slot-scope="scope">
          <el-tag type="info" v-if="scope.row.checkStatus == 0">待审核</el-tag>
          <el-tag type="success" v-if="scope.row.checkStatus == 1">审核成功</el-tag>
          <el-popover
            placement="top-start"
            width="200"
            trigger="hover"
            :content="'驳回原因:'+scope.row.checkRemark">
            <el-tag slot="reference" type="danger" v-if="scope.row.checkStatus == 2">审核不通过</el-tag>
          </el-popover>
        </template>
      </el-table-column>
      <el-table-column label="审核时间" align="center" prop="checkTime" />
      <el-table-column label="审核人" align="center" prop="checkBy" />
      <el-table-column label="操作" align="center" width="200" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            @click="handleAudit(scope.row,'details')"
            v-hasPermi="['teamMr:teamMr:details']"
          >详情</el-button>
          <el-button
            size="mini"
            type="text"
            @click="handleAudit(scope.row,'Audit')"
            v-hasPermi="['teamMr:teamMr:audit']"
            v-if="scope.row.checkStatus == 0 && name!=scope.row.createBy"
          >审核</el-button>
          <el-button
            size="mini"
            type="text"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['teamMr:teamMr:edit']"
            v-if="scope.row.checkStatus == 1 && name!=scope.row.createBy" 
          >编辑</el-button>
          <el-button
            size="mini"
            type="text"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['teamMr:teamMr:edit']"
            v-if="scope.row.checkStatus == 2 && name==scope.row.createBy" 
          >修改重新提交</el-button>
          <el-button
            size="mini"
            type="text"
            @click="handleDelete(scope.row,scope.index)"
            v-hasPermi="['teamMr:teamMr:delete']"
            v-if="(scope.row.checkStatus == 1 && name!=scope.row.createBy)||scope.row.checkStatus != 1"
          >删除</el-button>
          <el-dropdown size="mini" @command="(command) => handleCommand(command, scope.row,scope.index)">
            <el-button size="mini" type="text" icon="el-icon-d-arrow-right">更多</el-button>
            <el-dropdown-menu slot="dropdown">
              <el-dropdown-item command="handleResetPwd" icon="el-icon-key"
                v-if="scope.row.checkStatus == 1"
                v-hasPermi="['teamMr:teamMr:resetting']">重置密码</el-dropdown-item>
              <el-dropdown-item command="rechargeBox" icon="el-icon-key"
              v-if="scope.row.checkStatus == 1 && name!=scope.row.createBy && scope.row.checkStatus == 1" 
              v-hasPermi="['teamMr:teamMr:rechargeBox']"
                >账户充值</el-dropdown-item>
              <el-dropdown-item command="creditGranting" icon="el-icon-circle-check"
              v-if="scope.row.checkStatus == 1 && name!=scope.row.createBy && scope.row.checkStatus == 1" 
              v-hasPermi="['teamMr:teamMr:creditGranting']"
              >账户授信额度</el-dropdown-item>
              <el-dropdown-item command="creditGrantingBox" icon="el-icon-circle-check"
              v-if="scope.row.checkStatus == 1 && name!=scope.row.createBy && scope.row.checkStatus == 1"
              v-hasPermi="['teamMr:teamMr:creditGrantingBox']" 
              >账户授信欠款</el-dropdown-item>
              <el-dropdown-item command="orderAll" icon="el-icon-circle-check"
              v-hasPermi="['teamMr:teamMr:orderAll']" 
              >查看团购订单</el-dropdown-item>
            </el-dropdown-menu>
          </el-dropdown>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 新增/编辑弹框 -->
    <add-and-edit
      ref="addAndEdit"
      :dict="dict"
      @getList="getList"
    />

    <!-- 账户充值 -->
    <rechargeBox
      ref="rechargeBox"
      @getList="getList"
    />

    <!-- 账户授信余额 -->
    <creditGranting
      ref="creditGranting"
      @getList="getList"
    />

    <!-- 账户授信余额 -->
    <creditGrantingBox
      ref="creditGrantingBox"
      @getList="getList"
    />

    <!-- 账户授信余额 -->
    <orderAllBox
      ref="orderAllBox"
      @getList="getList"
    />

    <!-- 详情 / 审核 -->
    <auditBox ref="auditBox" :dict="dict" @getList="getList" />
    <el-dialog
      title="查看"
      :visible.sync="visibleStatus"
      width="600px"
      :destroy-on-close="true"
      :close-on-click-modal="false"
    >
      <div v-if="visibleType == 'img'">
        <el-image
          style="width: 400px; height: 100%"
          v-for="(item, index) in newObj.contractImgList"
          :key="index"
          :src="item"
          fit="cover"
        />
      </div>
      <div v-if="visibleType == 'html'">
        <div v-html="newObj.centent"></div>
      </div>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="visibleStatus = false">确 定</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>

import { pageList, deleteById, updateStatus } from '@/api/team/teamMr'
import addAndEdit from "./dialog/addAndEdit.vue";
import creditGranting from './dialog/creditGranting.vue';
import rechargeBox from './dialog/rechargeBox.vue';
import auditBox from './dialog/auditBox.vue';
import creditGrantingBox from './dialog/creditGrantingBox.vue';
import orderAllBox from './dialog/orderAllBox.vue';
import { mapGetters } from 'vuex'
export default {
  name: "agreement",
  dicts: ['team_type','order_form_type'],
  components: { addAndEdit, creditGranting, rechargeBox, auditBox, creditGrantingBox, orderAllBox },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 用户表格数据
      dataList: null,
      // 弹出层标题
      title: "",

      // 是否显示弹出层
      open: false,
      // 日期范围
      dateRange: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        type: undefined
      },
      statusList: [
        {id: 1, name: '未发布', value: 0},
        {id: 2, name: '发布', value: 1},
        {id: 3, name: '下架', value: 2},
      ],
      visibleStatus: false,
      newObj: {},
      visibleType: ''
    };
  },
  computed: {
    ...mapGetters([
      'name',
    ]),
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询列表 */
    getList() {
      this.loading = true;
      this.dataList = []
      pageList(this.addDateRange(this.queryParams, this.dateRange))
      .then(response => {
          this.dataList = response.data.rows;
          this.dataList.forEach(item =>{
            item.switchValue = item.status;
          })
          this.total = response.data.total;
          this.loading = false;
        }
      ).catch(()=>{
        this.dataList = []
        this.total = 0
        this.loading = false;
      })
    },
    // 取消按钮
    cancel() {
      this.open = false;
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.dateRange = [];
      this.$set(this.queryParams, 'name', '');
      this.$set(this.queryParams, 'type', '');
      this.$set(this.queryParams, 'salerPerson', '');
      this.$set(this.queryParams, 'createBy', '');
      this.queryParams.pageNum = 1;
      this.handleQuery();
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.$refs["addAndEdit"].openDialog("新增数据", null);
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.$refs["addAndEdit"].openDialog("修改数据", row);
    },
    /** 详情 或 审核  */
    handleAudit(row,type) {
      this.$refs["auditBox"].openDialog("审核数据", row, type);
    },
    /** 启用或者禁用按钮操作 */
    updateStatusApi(row) {
      this.$confirm("是否对团队名称为" + row.name + "的数据进行" + (row.status == 1 ? '禁用？' : '启用？'), '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        updateStatus({ id: row.id, status: row.status == 1 ? 0 : 1 }).then((res) => {
          if (res.code == 200) {
            this.$message({
              type: 'success',
              message: '操作成功!'
            });
            this.getList();
          }
        });
      }).catch(() => {});
    },
    /** 重置密码按钮操作 */
    resettingApi(row) {
      this.$confirm("是否对团队名称为" + row.name + "的数据进行密码重置？重置后的密码为123456！", '提示', {
        confirmButtonText: '确定',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(() => {
        updateStatus({ id: row.id, password: '123456' }).then((res) => {
          if (res.code == 200) {
            this.$message({
              type: 'success',
              message: '操作成功!'
            });
            this.getList();
          }
        });
      }).catch(() => {});
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      this.$modal.confirm('是否确认删除数据团队名称为"' + row.name + '"的数据项？').then(function() {
        return deleteById(row.id);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    },
    /** 查看按钮操作 */
    seeCenter(obj, type) {
      this.visibleStatus = true
      this.visibleType = type;
      this.newObj = obj;
      if(obj.contractImg){
        this.newObj.contractImgList = obj.contractImg.split(',')
      }
    },
    // 更多操作触发
    handleCommand(command, row,index) {
      switch (command) {
        case "handleResetPwd": // 重置密码
            this.resettingApi(row);
            break;
        case "rechargeBox":
            this.rechargeBoxFun(row);
            break;
        case "creditGranting":
            this.creditGrantingFun(row);
            break;
        case "creditGrantingBox":
            this.creditGrantingBoxFun(row);
            break;
        case "orderAll":
            this.orderAllBoxFun(row);
            break;
        default:
            break;
        }
    },
    creditGrantingFun(row) {
      this.$refs["creditGranting"].openDialog("账户授信额度", row);
    },
    rechargeBoxFun(row) {
      this.$refs["rechargeBox"].openDialog("账户充值", row);
    },
    creditGrantingBoxFun(row) {
      this.$refs["creditGrantingBox"].openDialog("账户授信欠款", row);
    },
    orderAllBoxFun(row) {
      this.$refs["orderAllBox"].openDialog("查看团购订单", row);
    },
  }
};
</script>
